#include "OgreMeshInstance.h"
#include "OgreTypeConverter.h"

namespace Ogre
{

	OgreMeshInstance::OgreMeshInstance(Entity *ent):
	GtpVisibilityPreprocessor::Intersectable(), mEntity(ent)
	{
	}

	void OgreMeshInstance::SetEntity(Entity *entity)
	{
		mEntity = entity;
	}

	Entity *OgreMeshInstance::GetEntity() const
	{ 
		return mEntity; 
	}
	
	GtpVisibilityPreprocessor::AxisAlignedBox3 OgreMeshInstance::GetBox() const
	{
		return OgreTypeConverter::ConvertFromOgre(mEntity->getWorldBoundingBox());
	}

	int OgreMeshInstance::CastRay(GtpVisibilityPreprocessor::Ray &ray)
	{
		return 0;
	}
	
	bool OgreMeshInstance::IsConvex() const
	{
		return true;
	}

	bool OgreMeshInstance::IsWatertight() const
	{
		return true;
	}

	float OgreMeshInstance::IntersectionComplexity()
	{
		return 1.0f;
	}
  
	int OgreMeshInstance::NumberOfFaces() const
	{
		return 0;
	}

	int OgreMeshInstance::Type() const
	{
		return OGRE_MESH_INSTANCE;
	}

	int OgreMeshInstance::GetRandomSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point,
		GtpVisibilityPreprocessor::Vector3 &normal)
	{
		return 0;
	}

	int OgreMeshInstance::GetRandomVisibleSurfacePoint(GtpVisibilityPreprocessor::Vector3 &point,
													   GtpVisibilityPreprocessor::Vector3 &normal,
													   const GtpVisibilityPreprocessor::Vector3 &viewpoint,
													   const int maxTries)
	{
		return 0;
	}
  
	ostream &OgreMeshInstance::Describe(ostream &s)
	{
		s << mEntity;
		return s;
	}
	
}